'''
Created on 14.04.2010

@author: gsu
'''

from nes_common.sql_operation import _Insert, _Update, _LastInsertId, _Select, _Delete, _DeleteAll

class Insert(_Insert):

    def __init__(self, table, values, quotedValues = None, idName = None):
        _Insert.__init__(self, table, values, quotedValues = quotedValues, idName = idName, replaceSymbol='?')
        
    def execute(self, context):
        values = self.values.values()
        sql = self.prepareStatement(context)
        context.cursor.execute("select IDENT_SEED('%s')" % context.tableName(self.table))
        identity = context.cursor.fetchone()[0]
        context.cursor.execute("SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE where TABLE_NAME='%s'" % context.tableName(self.table))
        columnKey = context.cursor.fetchone()[0]
        identity_insert = False
        if identity and columnKey and sql.find(columnKey)!=-1:
            context.cursor.execute('SET IDENTITY_INSERT %s ON; ' % context.tableName(self.table))
            identity_insert = True
        context.cursor.execute(sql, [ v() if callable(v) else v for v in values])
        if identity_insert:
            context.cursor.execute('SET IDENTITY_INSERT %s OFF; ' % context.tableName(self.table))

class Update(_Update):

    def __init__(self, table, fields, values, whereField, whereValue):
        _Update.__init__(self, table, fields, values, whereField, whereValue, replaceSymbol='?')
        
class LastInsertId(_LastInsertId):

    def execute(self, context):
        if self.value != None:
            return self.value
        sql = 'SELECT @@IDENTITY'
        context.cursor.execute(sql)
        for value in context.cursor:
            self.value = value[0]
        return self.value

class Select(_Select):

    def __init__(self, table, fields, whereFields, whereValues):
        _Select.__init__(self, table, fields, whereFields, whereValues, replaceSymbol='?')

class Delete(_Delete):

    def __init__(self, table, whereFields, whereValues):
        _Delete.__init__(self, table, whereFields, whereValues, replaceSymbol='?')

class DeleteAll(_DeleteAll):
    
    def execute(self, context):
        tableName = context.tableName(self.table)
        sql = "truncate table %s " % tableName
        context.cursor.execute(sql)
        context.emptyTables[self.table] = True
