# -*- coding: UTF-8 -*-

from nes_common.inserter import Inserter 
from cash.mysql import nes_exec
import ConfigParser
import sys
from nes_common import logger
from nes_command import Command


class DB_Inserter(Inserter):
    def __init__(self, shop, loadDictStatusSender=None, disableProgressFile=False):
        log = logger.Logger().getLogger(shop['shopId'])
        config = ConfigParser.RawConfigParser()
        if not config.read(sys.path[0] + "/../../../config/nes_load.ini"):
            log.error("Configuration file 'nes_load.ini' not found")
            sys.exit(1)
        host = config.get('mysql', 'host')
        port = config.getint('mysql', 'port')
        user = config.get('mysql', 'user')
        password = config.get('mysql', 'password')
        executor = nes_exec.Exec(host=host, port=port, user=user, password=password, database='dictionaries',
                                 shopCode=shop['shopId'], config=config, loadDictStatusSender=loadDictStatusSender)
        if disableProgressFile:
            executor.progressEnable = None

        log.info('Инициализация')
        Inserter.__init__(self, shop['shopId'], executor)

    def getCommand(self, simpleCommands):
        return Command(self.executor, self.shopCode, simpleCommands=simpleCommands, modes=['ANY', 'CASH'])
